#include<iostream>
#include<vector>
#include<fstream>
#include<algorithm>
#include <cmath>
#include<string>
#include <sys/time.h>
#include <sys/resource.h>

#define UP 1
#define LEFT 2
#define UPLEFT 3

using namespace std;


void LCS_lEngth(int **c, int **b, char *X, char *Y, int cornerX, int cornerY, int lengthX, int lengthY, int n, int m);
void print_LCS(int **b, char *X, int i, int j);

	


int main(int argc, char *argv[])
{
	
	int m, n, i;
	char *X, *Y;
	if(argc==3)	
	{	X=argv[1];
		Y=argv[2];
		m = strlen(X);
		n = strlen(Y);			
	}
	else
	{
		cout<<"Enter the length of first string:";
		cin>>m;
		X= new char[m+1];

		cout<<"Enter the length of second string:";
		cin>>n;
		Y = new char[n+1];


		for(i=0;i<m;++i)
			X[i] = rand()%26 + 97;
		X[m]='\n';

		for(i=0;i<n;++i)
			Y[i]= rand()%26 + 97;;
		Y[n] = '\n';
		i =0;
		cout<<"Strings are created randomly. To see the strings enter 1, any other number for cancel printing:";
		cin>>i;
		if(i==1)
		{
			cout<<X<<endl;
			cout<<Y<<endl;
		}
		
		
	}	
	int** c;
	int** b;
	c = new int*[m+1];
	b = new int*[m+1];
	
	for(i =0; i<= m; ++i)
	{
		c[i] = new int[n+1];
		b[i] = new int[n+1];
	}
	
	for(i = 0; i<=m; ++i)
		c[i][0] = 0;
	for(i = 0; i<=n; ++i)
		c[0][i] = 0;	
	
	int n1 = ceil(n/3);
	int m1 = ceil(m/3);
		
	//LCS_lEngth(c, b, X, Y, 1, 1, n1, m1, n, m );
	
	//LCS_lEngth(c, b, X, Y, n1+1, 1, n1, m1, n, m );
	//LCS_lEngth(c, b, X, Y, 1, m1+1, n1, m1, n, m );

	//LCS_lEngth(c, b, X, Y, n1+n1+1, 1, n, m1, n, m );
	//LCS_lEngth(c, b, X, Y, n1+1, m1+1, n1, m1, n, m );
	//LCS_lEngth(c, b, X, Y, 1, m1+m1+1, n1, m, n, m );

	//LCS_lEngth(c, b, X, Y, n1+n1+1, m1+1, n, m1, n, m );
	//LCS_lEngth(c, b, X, Y, n1+1, m1+m1+1, n1, m, n, m );

	LCS_lEngth(c, b, X, Y, 1, 1, n, m, n, m );

	cout<<"The length of LCS is: "<<c[m][n]<<endl;
	cout<<"Do you want to print the LCS ? (1 for yes, enter any other number to cancel):";
	cin>>i;
	if(i ==1)
		print_LCS(b, X, m, n);
	cout<<endl;
	
	for(i =0; i<= m; ++i)
	{
		delete [] c[i];
		delete [] b[i];
	}
	delete [] c;
	delete [] b;
	if(argc < 3)
	{	delete [] X;
		delete [] Y;
	}

	return 0;
}

void LCS_lEngth(int **c, int **b, char *X, char *Y, int cornerX, int cornerY, int lengthX, int lengthY, int n, int m)
{

	int i, j;
	lengthX += (cornerX-1);
	lengthY += (cornerY-1);

	if(lengthX > n) lengthX = n;
	if(lengthY > m) lengthY = m;

	for(i = cornerY; i<=  lengthY; ++i)
	{
		for(j = cornerX; j<=  lengthX; ++j)
		{
			if(X[i-1] == Y[j-1])
			{
				c[i][j] = c[i-1][j-1] +1;
				b[i][j] = UPLEFT;
			}
			else 
			{	if(c[i-1][j] >= c[i][j-1])
				{
					c[i][j] = c[i-1][j];
					b[i][j] = UP;
				}
				else
				{
					c[i][j] = c[i][j-1];
					b[i][j] = LEFT;
				}
			}
		}	
	}
}


void print_LCS(int **b, char *X, int i, int j)
{
	if(i > 0 && j > 0)
	{
		if(b[i][j]== UPLEFT)
		{
			print_LCS(b, X, i-1, j-1);
			cout<<X[i-1];
		}
		else if(b[i][j]== UP)
			print_LCS(b, X, i-1, j);
		else
			print_LCS(b, X, i, j-1);
	}
}




